/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * RISCV Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper function for extracting fields from encoded instructions.
template<typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits) {
    assert(startBit + numBits <= (sizeof(InsnType)*8) &&
           "Instruction field out of bounds!");
    InsnType fieldMask;
    if (numBits == sizeof(InsnType)*8)
      fieldMask = (InsnType)(-1LL);
    else
      fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
    return (insn & fieldMask) >> startBit;
}

static const uint8_t DecoderTable16[] = {
/* 0 */       MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 3 */       MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 69
/* 8 */       MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 11 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 25
/* 16 */      MCD::OPC_CheckPredicate, 0, 116, 2, 0, // Skip to: 649
/* 21 */      MCD::OPC_Decode, 235, 1, 0, // Opcode: C_ADDI4SPN
/* 25 */      MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 55
/* 30 */      MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 46
/* 35 */      MCD::OPC_CheckField, 7, 6, 0, 4, 0, 0, // Skip to: 46
/* 42 */      MCD::OPC_Decode, 134, 2, 1, // Opcode: C_NOP
/* 46 */      MCD::OPC_CheckPredicate, 0, 86, 2, 0, // Skip to: 649
/* 51 */      MCD::OPC_Decode, 233, 1, 2, // Opcode: C_ADDI
/* 55 */      MCD::OPC_FilterValue, 2, 77, 2, 0, // Skip to: 649
/* 60 */      MCD::OPC_CheckPredicate, 0, 72, 2, 0, // Skip to: 649
/* 65 */      MCD::OPC_Decode, 138, 2, 3, // Opcode: C_SLLI
/* 69 */      MCD::OPC_FilterValue, 1, 45, 0, 0, // Skip to: 119
/* 74 */      MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 77 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 91
/* 82 */      MCD::OPC_CheckPredicate, 1, 50, 2, 0, // Skip to: 649
/* 87 */      MCD::OPC_Decode, 243, 1, 4, // Opcode: C_FLD
/* 91 */      MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 105
/* 96 */      MCD::OPC_CheckPredicate, 2, 36, 2, 0, // Skip to: 649
/* 101 */     MCD::OPC_Decode, 236, 1, 2, // Opcode: C_ADDIW
/* 105 */     MCD::OPC_FilterValue, 2, 27, 2, 0, // Skip to: 649
/* 110 */     MCD::OPC_CheckPredicate, 1, 22, 2, 0, // Skip to: 649
/* 115 */     MCD::OPC_Decode, 244, 1, 5, // Opcode: C_FLDSP
/* 119 */     MCD::OPC_FilterValue, 2, 45, 0, 0, // Skip to: 169
/* 124 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 127 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 141
/* 132 */     MCD::OPC_CheckPredicate, 0, 0, 2, 0, // Skip to: 649
/* 137 */     MCD::OPC_Decode, 131, 2, 6, // Opcode: C_LW
/* 141 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 155
/* 146 */     MCD::OPC_CheckPredicate, 0, 242, 1, 0, // Skip to: 649
/* 151 */     MCD::OPC_Decode, 129, 2, 7, // Opcode: C_LI
/* 155 */     MCD::OPC_FilterValue, 2, 233, 1, 0, // Skip to: 649
/* 160 */     MCD::OPC_CheckPredicate, 0, 228, 1, 0, // Skip to: 649
/* 165 */     MCD::OPC_Decode, 132, 2, 8, // Opcode: C_LWSP
/* 169 */     MCD::OPC_FilterValue, 3, 61, 0, 0, // Skip to: 235
/* 174 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 177 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 191
/* 182 */     MCD::OPC_CheckPredicate, 2, 206, 1, 0, // Skip to: 649
/* 187 */     MCD::OPC_Decode, 255, 1, 9, // Opcode: C_LD
/* 191 */     MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 221
/* 196 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 212
/* 201 */     MCD::OPC_CheckField, 7, 5, 2, 4, 0, 0, // Skip to: 212
/* 208 */     MCD::OPC_Decode, 234, 1, 10, // Opcode: C_ADDI16SP
/* 212 */     MCD::OPC_CheckPredicate, 0, 176, 1, 0, // Skip to: 649
/* 217 */     MCD::OPC_Decode, 130, 2, 11, // Opcode: C_LUI
/* 221 */     MCD::OPC_FilterValue, 2, 167, 1, 0, // Skip to: 649
/* 226 */     MCD::OPC_CheckPredicate, 2, 162, 1, 0, // Skip to: 649
/* 231 */     MCD::OPC_Decode, 128, 2, 12, // Opcode: C_LDSP
/* 235 */     MCD::OPC_FilterValue, 4, 3, 1, 0, // Skip to: 499
/* 240 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 243 */     MCD::OPC_FilterValue, 1, 167, 0, 0, // Skip to: 415
/* 248 */     MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 251 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 265
/* 256 */     MCD::OPC_CheckPredicate, 0, 132, 1, 0, // Skip to: 649
/* 261 */     MCD::OPC_Decode, 140, 2, 13, // Opcode: C_SRLI
/* 265 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 279
/* 270 */     MCD::OPC_CheckPredicate, 0, 118, 1, 0, // Skip to: 649
/* 275 */     MCD::OPC_Decode, 139, 2, 13, // Opcode: C_SRAI
/* 279 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 293
/* 284 */     MCD::OPC_CheckPredicate, 0, 104, 1, 0, // Skip to: 649
/* 289 */     MCD::OPC_Decode, 239, 1, 14, // Opcode: C_ANDI
/* 293 */     MCD::OPC_FilterValue, 3, 95, 1, 0, // Skip to: 649
/* 298 */     MCD::OPC_ExtractField, 5, 2,  // Inst{6-5} ...
/* 301 */     MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 337
/* 306 */     MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 309 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 323
/* 314 */     MCD::OPC_CheckPredicate, 0, 74, 1, 0, // Skip to: 649
/* 319 */     MCD::OPC_Decode, 141, 2, 15, // Opcode: C_SUB
/* 323 */     MCD::OPC_FilterValue, 1, 65, 1, 0, // Skip to: 649
/* 328 */     MCD::OPC_CheckPredicate, 2, 60, 1, 0, // Skip to: 649
/* 333 */     MCD::OPC_Decode, 142, 2, 15, // Opcode: C_SUBW
/* 337 */     MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 373
/* 342 */     MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 345 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 359
/* 350 */     MCD::OPC_CheckPredicate, 0, 38, 1, 0, // Skip to: 649
/* 355 */     MCD::OPC_Decode, 145, 2, 15, // Opcode: C_XOR
/* 359 */     MCD::OPC_FilterValue, 1, 29, 1, 0, // Skip to: 649
/* 364 */     MCD::OPC_CheckPredicate, 2, 24, 1, 0, // Skip to: 649
/* 369 */     MCD::OPC_Decode, 237, 1, 15, // Opcode: C_ADDW
/* 373 */     MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 394
/* 378 */     MCD::OPC_CheckPredicate, 0, 10, 1, 0, // Skip to: 649
/* 383 */     MCD::OPC_CheckField, 12, 1, 0, 3, 1, 0, // Skip to: 649
/* 390 */     MCD::OPC_Decode, 135, 2, 15, // Opcode: C_OR
/* 394 */     MCD::OPC_FilterValue, 3, 250, 0, 0, // Skip to: 649
/* 399 */     MCD::OPC_CheckPredicate, 0, 245, 0, 0, // Skip to: 649
/* 404 */     MCD::OPC_CheckField, 12, 1, 0, 238, 0, 0, // Skip to: 649
/* 411 */     MCD::OPC_Decode, 238, 1, 15, // Opcode: C_AND
/* 415 */     MCD::OPC_FilterValue, 2, 229, 0, 0, // Skip to: 649
/* 420 */     MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 423 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 453
/* 428 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 444
/* 433 */     MCD::OPC_CheckField, 2, 5, 0, 4, 0, 0, // Skip to: 444
/* 440 */     MCD::OPC_Decode, 254, 1, 16, // Opcode: C_JR
/* 444 */     MCD::OPC_CheckPredicate, 0, 200, 0, 0, // Skip to: 649
/* 449 */     MCD::OPC_Decode, 133, 2, 17, // Opcode: C_MV
/* 453 */     MCD::OPC_FilterValue, 1, 191, 0, 0, // Skip to: 649
/* 458 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 474
/* 463 */     MCD::OPC_CheckField, 2, 10, 0, 4, 0, 0, // Skip to: 474
/* 470 */     MCD::OPC_Decode, 242, 1, 1, // Opcode: C_EBREAK
/* 474 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 490
/* 479 */     MCD::OPC_CheckField, 2, 5, 0, 4, 0, 0, // Skip to: 490
/* 486 */     MCD::OPC_Decode, 253, 1, 16, // Opcode: C_JALR
/* 490 */     MCD::OPC_CheckPredicate, 0, 154, 0, 0, // Skip to: 649
/* 495 */     MCD::OPC_Decode, 232, 1, 18, // Opcode: C_ADD
/* 499 */     MCD::OPC_FilterValue, 5, 45, 0, 0, // Skip to: 549
/* 504 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 507 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 521
/* 512 */     MCD::OPC_CheckPredicate, 1, 132, 0, 0, // Skip to: 649
/* 517 */     MCD::OPC_Decode, 247, 1, 4, // Opcode: C_FSD
/* 521 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 535
/* 526 */     MCD::OPC_CheckPredicate, 0, 118, 0, 0, // Skip to: 649
/* 531 */     MCD::OPC_Decode, 251, 1, 19, // Opcode: C_J
/* 535 */     MCD::OPC_FilterValue, 2, 109, 0, 0, // Skip to: 649
/* 540 */     MCD::OPC_CheckPredicate, 1, 104, 0, 0, // Skip to: 649
/* 545 */     MCD::OPC_Decode, 248, 1, 20, // Opcode: C_FSDSP
/* 549 */     MCD::OPC_FilterValue, 6, 45, 0, 0, // Skip to: 599
/* 554 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 557 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 571
/* 562 */     MCD::OPC_CheckPredicate, 0, 82, 0, 0, // Skip to: 649
/* 567 */     MCD::OPC_Decode, 143, 2, 6, // Opcode: C_SW
/* 571 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 585
/* 576 */     MCD::OPC_CheckPredicate, 0, 68, 0, 0, // Skip to: 649
/* 581 */     MCD::OPC_Decode, 240, 1, 21, // Opcode: C_BEQZ
/* 585 */     MCD::OPC_FilterValue, 2, 59, 0, 0, // Skip to: 649
/* 590 */     MCD::OPC_CheckPredicate, 0, 54, 0, 0, // Skip to: 649
/* 595 */     MCD::OPC_Decode, 144, 2, 22, // Opcode: C_SWSP
/* 599 */     MCD::OPC_FilterValue, 7, 45, 0, 0, // Skip to: 649
/* 604 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 607 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 621
/* 612 */     MCD::OPC_CheckPredicate, 2, 32, 0, 0, // Skip to: 649
/* 617 */     MCD::OPC_Decode, 136, 2, 9, // Opcode: C_SD
/* 621 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 635
/* 626 */     MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 649
/* 631 */     MCD::OPC_Decode, 241, 1, 21, // Opcode: C_BNEZ
/* 635 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 649
/* 640 */     MCD::OPC_CheckPredicate, 2, 4, 0, 0, // Skip to: 649
/* 645 */     MCD::OPC_Decode, 137, 2, 23, // Opcode: C_SDSP
/* 649 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTable32[] = {
/* 0 */       MCD::OPC_ExtractField, 0, 7,  // Inst{6-0} ...
/* 3 */       MCD::OPC_FilterValue, 3, 76, 0, 0, // Skip to: 84
/* 8 */       MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 11 */      MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 20
/* 16 */      MCD::OPC_Decode, 219, 2, 24, // Opcode: LB
/* 20 */      MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 29
/* 25 */      MCD::OPC_Decode, 222, 2, 24, // Opcode: LH
/* 29 */      MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 38
/* 34 */      MCD::OPC_Decode, 233, 2, 24, // Opcode: LW
/* 38 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 52
/* 43 */      MCD::OPC_CheckPredicate, 3, 35, 15, 0, // Skip to: 3923
/* 48 */      MCD::OPC_Decode, 221, 2, 24, // Opcode: LD
/* 52 */      MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 61
/* 57 */      MCD::OPC_Decode, 220, 2, 24, // Opcode: LBU
/* 61 */      MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 70
/* 66 */      MCD::OPC_Decode, 223, 2, 24, // Opcode: LHU
/* 70 */      MCD::OPC_FilterValue, 6, 8, 15, 0, // Skip to: 3923
/* 75 */      MCD::OPC_CheckPredicate, 3, 3, 15, 0, // Skip to: 3923
/* 80 */      MCD::OPC_Decode, 234, 2, 24, // Opcode: LWU
/* 84 */      MCD::OPC_FilterValue, 7, 31, 0, 0, // Skip to: 120
/* 89 */      MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 92 */      MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 106
/* 97 */      MCD::OPC_CheckPredicate, 4, 237, 14, 0, // Skip to: 3923
/* 102 */     MCD::OPC_Decode, 186, 2, 25, // Opcode: FLW
/* 106 */     MCD::OPC_FilterValue, 3, 228, 14, 0, // Skip to: 3923
/* 111 */     MCD::OPC_CheckPredicate, 5, 223, 14, 0, // Skip to: 3923
/* 116 */     MCD::OPC_Decode, 181, 2, 26, // Opcode: FLD
/* 120 */     MCD::OPC_FilterValue, 15, 52, 0, 0, // Skip to: 177
/* 125 */     MCD::OPC_ExtractField, 7, 13,  // Inst{19-7} ...
/* 128 */     MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 161
/* 133 */     MCD::OPC_ExtractField, 28, 4,  // Inst{31-28} ...
/* 136 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 145
/* 141 */     MCD::OPC_Decode, 176, 2, 27, // Opcode: FENCE
/* 145 */     MCD::OPC_FilterValue, 8, 189, 14, 0, // Skip to: 3923
/* 150 */     MCD::OPC_CheckField, 20, 8, 51, 182, 14, 0, // Skip to: 3923
/* 157 */     MCD::OPC_Decode, 178, 2, 1, // Opcode: FENCE_TSO
/* 161 */     MCD::OPC_FilterValue, 32, 173, 14, 0, // Skip to: 3923
/* 166 */     MCD::OPC_CheckField, 20, 12, 0, 166, 14, 0, // Skip to: 3923
/* 173 */     MCD::OPC_Decode, 177, 2, 1, // Opcode: FENCE_I
/* 177 */     MCD::OPC_FilterValue, 19, 99, 0, 0, // Skip to: 281
/* 182 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 185 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 194
/* 190 */     MCD::OPC_Decode, 142, 1, 24, // Opcode: ADDI
/* 194 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 210
/* 199 */     MCD::OPC_CheckField, 26, 6, 0, 133, 14, 0, // Skip to: 3923
/* 206 */     MCD::OPC_Decode, 132, 3, 28, // Opcode: SLLI
/* 210 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 219
/* 215 */     MCD::OPC_Decode, 136, 3, 24, // Opcode: SLTI
/* 219 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 228
/* 224 */     MCD::OPC_Decode, 137, 3, 24, // Opcode: SLTIU
/* 228 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 237
/* 233 */     MCD::OPC_Decode, 154, 3, 24, // Opcode: XORI
/* 237 */     MCD::OPC_FilterValue, 5, 21, 0, 0, // Skip to: 263
/* 242 */     MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 245 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 254
/* 250 */     MCD::OPC_Decode, 145, 3, 28, // Opcode: SRLI
/* 254 */     MCD::OPC_FilterValue, 16, 80, 14, 0, // Skip to: 3923
/* 259 */     MCD::OPC_Decode, 140, 3, 28, // Opcode: SRAI
/* 263 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 272
/* 268 */     MCD::OPC_Decode, 242, 2, 24, // Opcode: ORI
/* 272 */     MCD::OPC_FilterValue, 7, 62, 14, 0, // Skip to: 3923
/* 277 */     MCD::OPC_Decode, 218, 1, 24, // Opcode: ANDI
/* 281 */     MCD::OPC_FilterValue, 23, 4, 0, 0, // Skip to: 290
/* 286 */     MCD::OPC_Decode, 219, 1, 29, // Opcode: AUIPC
/* 290 */     MCD::OPC_FilterValue, 27, 74, 0, 0, // Skip to: 369
/* 295 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 298 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 312
/* 303 */     MCD::OPC_CheckPredicate, 3, 31, 14, 0, // Skip to: 3923
/* 308 */     MCD::OPC_Decode, 143, 1, 24, // Opcode: ADDIW
/* 312 */     MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 333
/* 317 */     MCD::OPC_CheckPredicate, 3, 17, 14, 0, // Skip to: 3923
/* 322 */     MCD::OPC_CheckField, 25, 7, 0, 10, 14, 0, // Skip to: 3923
/* 329 */     MCD::OPC_Decode, 133, 3, 30, // Opcode: SLLIW
/* 333 */     MCD::OPC_FilterValue, 5, 1, 14, 0, // Skip to: 3923
/* 338 */     MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 341 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 355
/* 346 */     MCD::OPC_CheckPredicate, 3, 244, 13, 0, // Skip to: 3923
/* 351 */     MCD::OPC_Decode, 146, 3, 30, // Opcode: SRLIW
/* 355 */     MCD::OPC_FilterValue, 32, 235, 13, 0, // Skip to: 3923
/* 360 */     MCD::OPC_CheckPredicate, 3, 230, 13, 0, // Skip to: 3923
/* 365 */     MCD::OPC_Decode, 141, 3, 30, // Opcode: SRAIW
/* 369 */     MCD::OPC_FilterValue, 35, 44, 0, 0, // Skip to: 418
/* 374 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 377 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 386
/* 382 */     MCD::OPC_Decode, 247, 2, 31, // Opcode: SB
/* 386 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 395
/* 391 */     MCD::OPC_Decode, 130, 3, 31, // Opcode: SH
/* 395 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 404
/* 400 */     MCD::OPC_Decode, 150, 3, 31, // Opcode: SW
/* 404 */     MCD::OPC_FilterValue, 3, 186, 13, 0, // Skip to: 3923
/* 409 */     MCD::OPC_CheckPredicate, 3, 181, 13, 0, // Skip to: 3923
/* 414 */     MCD::OPC_Decode, 128, 3, 31, // Opcode: SD
/* 418 */     MCD::OPC_FilterValue, 39, 31, 0, 0, // Skip to: 454
/* 423 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 426 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 440
/* 431 */     MCD::OPC_CheckPredicate, 4, 159, 13, 0, // Skip to: 3923
/* 436 */     MCD::OPC_Decode, 216, 2, 32, // Opcode: FSW
/* 440 */     MCD::OPC_FilterValue, 3, 150, 13, 0, // Skip to: 3923
/* 445 */     MCD::OPC_CheckPredicate, 5, 145, 13, 0, // Skip to: 3923
/* 450 */     MCD::OPC_Decode, 205, 2, 33, // Opcode: FSD
/* 454 */     MCD::OPC_FilterValue, 47, 107, 6, 0, // Skip to: 2102
/* 459 */     MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 462 */     MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 498
/* 467 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 470 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 484
/* 475 */     MCD::OPC_CheckPredicate, 6, 115, 13, 0, // Skip to: 3923
/* 480 */     MCD::OPC_Decode, 149, 1, 34, // Opcode: AMOADD_W
/* 484 */     MCD::OPC_FilterValue, 3, 106, 13, 0, // Skip to: 3923
/* 489 */     MCD::OPC_CheckPredicate, 7, 101, 13, 0, // Skip to: 3923
/* 494 */     MCD::OPC_Decode, 145, 1, 34, // Opcode: AMOADD_D
/* 498 */     MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 534
/* 503 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 506 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 520
/* 511 */     MCD::OPC_CheckPredicate, 6, 79, 13, 0, // Skip to: 3923
/* 516 */     MCD::OPC_Decode, 152, 1, 34, // Opcode: AMOADD_W_RL
/* 520 */     MCD::OPC_FilterValue, 3, 70, 13, 0, // Skip to: 3923
/* 525 */     MCD::OPC_CheckPredicate, 7, 65, 13, 0, // Skip to: 3923
/* 530 */     MCD::OPC_Decode, 148, 1, 34, // Opcode: AMOADD_D_RL
/* 534 */     MCD::OPC_FilterValue, 2, 31, 0, 0, // Skip to: 570
/* 539 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 542 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 556
/* 547 */     MCD::OPC_CheckPredicate, 6, 43, 13, 0, // Skip to: 3923
/* 552 */     MCD::OPC_Decode, 150, 1, 34, // Opcode: AMOADD_W_AQ
/* 556 */     MCD::OPC_FilterValue, 3, 34, 13, 0, // Skip to: 3923
/* 561 */     MCD::OPC_CheckPredicate, 7, 29, 13, 0, // Skip to: 3923
/* 566 */     MCD::OPC_Decode, 146, 1, 34, // Opcode: AMOADD_D_AQ
/* 570 */     MCD::OPC_FilterValue, 3, 31, 0, 0, // Skip to: 606
/* 575 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 578 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 592
/* 583 */     MCD::OPC_CheckPredicate, 6, 7, 13, 0, // Skip to: 3923
/* 588 */     MCD::OPC_Decode, 151, 1, 34, // Opcode: AMOADD_W_AQ_RL
/* 592 */     MCD::OPC_FilterValue, 3, 254, 12, 0, // Skip to: 3923
/* 597 */     MCD::OPC_CheckPredicate, 7, 249, 12, 0, // Skip to: 3923
/* 602 */     MCD::OPC_Decode, 147, 1, 34, // Opcode: AMOADD_D_AQ_RL
/* 606 */     MCD::OPC_FilterValue, 4, 31, 0, 0, // Skip to: 642
/* 611 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 614 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 628
/* 619 */     MCD::OPC_CheckPredicate, 6, 227, 12, 0, // Skip to: 3923
/* 624 */     MCD::OPC_Decode, 205, 1, 34, // Opcode: AMOSWAP_W
/* 628 */     MCD::OPC_FilterValue, 3, 218, 12, 0, // Skip to: 3923
/* 633 */     MCD::OPC_CheckPredicate, 7, 213, 12, 0, // Skip to: 3923
/* 638 */     MCD::OPC_Decode, 201, 1, 34, // Opcode: AMOSWAP_D
/* 642 */     MCD::OPC_FilterValue, 5, 31, 0, 0, // Skip to: 678
/* 647 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 650 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 664
/* 655 */     MCD::OPC_CheckPredicate, 6, 191, 12, 0, // Skip to: 3923
/* 660 */     MCD::OPC_Decode, 208, 1, 34, // Opcode: AMOSWAP_W_RL
/* 664 */     MCD::OPC_FilterValue, 3, 182, 12, 0, // Skip to: 3923
/* 669 */     MCD::OPC_CheckPredicate, 7, 177, 12, 0, // Skip to: 3923
/* 674 */     MCD::OPC_Decode, 204, 1, 34, // Opcode: AMOSWAP_D_RL
/* 678 */     MCD::OPC_FilterValue, 6, 31, 0, 0, // Skip to: 714
/* 683 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 686 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 700
/* 691 */     MCD::OPC_CheckPredicate, 6, 155, 12, 0, // Skip to: 3923
/* 696 */     MCD::OPC_Decode, 206, 1, 34, // Opcode: AMOSWAP_W_AQ
/* 700 */     MCD::OPC_FilterValue, 3, 146, 12, 0, // Skip to: 3923
/* 705 */     MCD::OPC_CheckPredicate, 7, 141, 12, 0, // Skip to: 3923
/* 710 */     MCD::OPC_Decode, 202, 1, 34, // Opcode: AMOSWAP_D_AQ
/* 714 */     MCD::OPC_FilterValue, 7, 31, 0, 0, // Skip to: 750
/* 719 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 722 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 736
/* 727 */     MCD::OPC_CheckPredicate, 6, 119, 12, 0, // Skip to: 3923
/* 732 */     MCD::OPC_Decode, 207, 1, 34, // Opcode: AMOSWAP_W_AQ_RL
/* 736 */     MCD::OPC_FilterValue, 3, 110, 12, 0, // Skip to: 3923
/* 741 */     MCD::OPC_CheckPredicate, 7, 105, 12, 0, // Skip to: 3923
/* 746 */     MCD::OPC_Decode, 203, 1, 34, // Opcode: AMOSWAP_D_AQ_RL
/* 750 */     MCD::OPC_FilterValue, 8, 45, 0, 0, // Skip to: 800
/* 755 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 758 */     MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 779
/* 763 */     MCD::OPC_CheckPredicate, 6, 83, 12, 0, // Skip to: 3923
/* 768 */     MCD::OPC_CheckField, 20, 5, 0, 76, 12, 0, // Skip to: 3923
/* 775 */     MCD::OPC_Decode, 228, 2, 35, // Opcode: LR_W
/* 779 */     MCD::OPC_FilterValue, 3, 67, 12, 0, // Skip to: 3923
/* 784 */     MCD::OPC_CheckPredicate, 7, 62, 12, 0, // Skip to: 3923
/* 789 */     MCD::OPC_CheckField, 20, 5, 0, 55, 12, 0, // Skip to: 3923
/* 796 */     MCD::OPC_Decode, 224, 2, 35, // Opcode: LR_D
/* 800 */     MCD::OPC_FilterValue, 9, 45, 0, 0, // Skip to: 850
/* 805 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 808 */     MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 829
/* 813 */     MCD::OPC_CheckPredicate, 6, 33, 12, 0, // Skip to: 3923
/* 818 */     MCD::OPC_CheckField, 20, 5, 0, 26, 12, 0, // Skip to: 3923
/* 825 */     MCD::OPC_Decode, 231, 2, 35, // Opcode: LR_W_RL
/* 829 */     MCD::OPC_FilterValue, 3, 17, 12, 0, // Skip to: 3923
/* 834 */     MCD::OPC_CheckPredicate, 7, 12, 12, 0, // Skip to: 3923
/* 839 */     MCD::OPC_CheckField, 20, 5, 0, 5, 12, 0, // Skip to: 3923
/* 846 */     MCD::OPC_Decode, 227, 2, 35, // Opcode: LR_D_RL
/* 850 */     MCD::OPC_FilterValue, 10, 45, 0, 0, // Skip to: 900
/* 855 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 858 */     MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 879
/* 863 */     MCD::OPC_CheckPredicate, 6, 239, 11, 0, // Skip to: 3923
/* 868 */     MCD::OPC_CheckField, 20, 5, 0, 232, 11, 0, // Skip to: 3923
/* 875 */     MCD::OPC_Decode, 229, 2, 35, // Opcode: LR_W_AQ
/* 879 */     MCD::OPC_FilterValue, 3, 223, 11, 0, // Skip to: 3923
/* 884 */     MCD::OPC_CheckPredicate, 7, 218, 11, 0, // Skip to: 3923
/* 889 */     MCD::OPC_CheckField, 20, 5, 0, 211, 11, 0, // Skip to: 3923
/* 896 */     MCD::OPC_Decode, 225, 2, 35, // Opcode: LR_D_AQ
/* 900 */     MCD::OPC_FilterValue, 11, 45, 0, 0, // Skip to: 950
/* 905 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 908 */     MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 929
/* 913 */     MCD::OPC_CheckPredicate, 6, 189, 11, 0, // Skip to: 3923
/* 918 */     MCD::OPC_CheckField, 20, 5, 0, 182, 11, 0, // Skip to: 3923
/* 925 */     MCD::OPC_Decode, 230, 2, 35, // Opcode: LR_W_AQ_RL
/* 929 */     MCD::OPC_FilterValue, 3, 173, 11, 0, // Skip to: 3923
/* 934 */     MCD::OPC_CheckPredicate, 7, 168, 11, 0, // Skip to: 3923
/* 939 */     MCD::OPC_CheckField, 20, 5, 0, 161, 11, 0, // Skip to: 3923
/* 946 */     MCD::OPC_Decode, 226, 2, 35, // Opcode: LR_D_AQ_RL
/* 950 */     MCD::OPC_FilterValue, 12, 31, 0, 0, // Skip to: 986
/* 955 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 958 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 972
/* 963 */     MCD::OPC_CheckPredicate, 6, 139, 11, 0, // Skip to: 3923
/* 968 */     MCD::OPC_Decode, 252, 2, 34, // Opcode: SC_W
/* 972 */     MCD::OPC_FilterValue, 3, 130, 11, 0, // Skip to: 3923
/* 977 */     MCD::OPC_CheckPredicate, 7, 125, 11, 0, // Skip to: 3923
/* 982 */     MCD::OPC_Decode, 248, 2, 34, // Opcode: SC_D
/* 986 */     MCD::OPC_FilterValue, 13, 31, 0, 0, // Skip to: 1022
/* 991 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 994 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1008
/* 999 */     MCD::OPC_CheckPredicate, 6, 103, 11, 0, // Skip to: 3923
/* 1004 */    MCD::OPC_Decode, 255, 2, 34, // Opcode: SC_W_RL
/* 1008 */    MCD::OPC_FilterValue, 3, 94, 11, 0, // Skip to: 3923
/* 1013 */    MCD::OPC_CheckPredicate, 7, 89, 11, 0, // Skip to: 3923
/* 1018 */    MCD::OPC_Decode, 251, 2, 34, // Opcode: SC_D_RL
/* 1022 */    MCD::OPC_FilterValue, 14, 31, 0, 0, // Skip to: 1058
/* 1027 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1030 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1044
/* 1035 */    MCD::OPC_CheckPredicate, 6, 67, 11, 0, // Skip to: 3923
/* 1040 */    MCD::OPC_Decode, 253, 2, 34, // Opcode: SC_W_AQ
/* 1044 */    MCD::OPC_FilterValue, 3, 58, 11, 0, // Skip to: 3923
/* 1049 */    MCD::OPC_CheckPredicate, 7, 53, 11, 0, // Skip to: 3923
/* 1054 */    MCD::OPC_Decode, 249, 2, 34, // Opcode: SC_D_AQ
/* 1058 */    MCD::OPC_FilterValue, 15, 31, 0, 0, // Skip to: 1094
/* 1063 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1066 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1080
/* 1071 */    MCD::OPC_CheckPredicate, 6, 31, 11, 0, // Skip to: 3923
/* 1076 */    MCD::OPC_Decode, 254, 2, 34, // Opcode: SC_W_AQ_RL
/* 1080 */    MCD::OPC_FilterValue, 3, 22, 11, 0, // Skip to: 3923
/* 1085 */    MCD::OPC_CheckPredicate, 7, 17, 11, 0, // Skip to: 3923
/* 1090 */    MCD::OPC_Decode, 250, 2, 34, // Opcode: SC_D_AQ_RL
/* 1094 */    MCD::OPC_FilterValue, 16, 31, 0, 0, // Skip to: 1130
/* 1099 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1102 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1116
/* 1107 */    MCD::OPC_CheckPredicate, 6, 251, 10, 0, // Skip to: 3923
/* 1112 */    MCD::OPC_Decode, 213, 1, 34, // Opcode: AMOXOR_W
/* 1116 */    MCD::OPC_FilterValue, 3, 242, 10, 0, // Skip to: 3923
/* 1121 */    MCD::OPC_CheckPredicate, 7, 237, 10, 0, // Skip to: 3923
/* 1126 */    MCD::OPC_Decode, 209, 1, 34, // Opcode: AMOXOR_D
/* 1130 */    MCD::OPC_FilterValue, 17, 31, 0, 0, // Skip to: 1166
/* 1135 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1138 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1152
/* 1143 */    MCD::OPC_CheckPredicate, 6, 215, 10, 0, // Skip to: 3923
/* 1148 */    MCD::OPC_Decode, 216, 1, 34, // Opcode: AMOXOR_W_RL
/* 1152 */    MCD::OPC_FilterValue, 3, 206, 10, 0, // Skip to: 3923
/* 1157 */    MCD::OPC_CheckPredicate, 7, 201, 10, 0, // Skip to: 3923
/* 1162 */    MCD::OPC_Decode, 212, 1, 34, // Opcode: AMOXOR_D_RL
/* 1166 */    MCD::OPC_FilterValue, 18, 31, 0, 0, // Skip to: 1202
/* 1171 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1174 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1188
/* 1179 */    MCD::OPC_CheckPredicate, 6, 179, 10, 0, // Skip to: 3923
/* 1184 */    MCD::OPC_Decode, 214, 1, 34, // Opcode: AMOXOR_W_AQ
/* 1188 */    MCD::OPC_FilterValue, 3, 170, 10, 0, // Skip to: 3923
/* 1193 */    MCD::OPC_CheckPredicate, 7, 165, 10, 0, // Skip to: 3923
/* 1198 */    MCD::OPC_Decode, 210, 1, 34, // Opcode: AMOXOR_D_AQ
/* 1202 */    MCD::OPC_FilterValue, 19, 31, 0, 0, // Skip to: 1238
/* 1207 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1210 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1224
/* 1215 */    MCD::OPC_CheckPredicate, 6, 143, 10, 0, // Skip to: 3923
/* 1220 */    MCD::OPC_Decode, 215, 1, 34, // Opcode: AMOXOR_W_AQ_RL
/* 1224 */    MCD::OPC_FilterValue, 3, 134, 10, 0, // Skip to: 3923
/* 1229 */    MCD::OPC_CheckPredicate, 7, 129, 10, 0, // Skip to: 3923
/* 1234 */    MCD::OPC_Decode, 211, 1, 34, // Opcode: AMOXOR_D_AQ_RL
/* 1238 */    MCD::OPC_FilterValue, 32, 31, 0, 0, // Skip to: 1274
/* 1243 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1246 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1260
/* 1251 */    MCD::OPC_CheckPredicate, 6, 107, 10, 0, // Skip to: 3923
/* 1256 */    MCD::OPC_Decode, 197, 1, 34, // Opcode: AMOOR_W
/* 1260 */    MCD::OPC_FilterValue, 3, 98, 10, 0, // Skip to: 3923
/* 1265 */    MCD::OPC_CheckPredicate, 7, 93, 10, 0, // Skip to: 3923
/* 1270 */    MCD::OPC_Decode, 193, 1, 34, // Opcode: AMOOR_D
/* 1274 */    MCD::OPC_FilterValue, 33, 31, 0, 0, // Skip to: 1310
/* 1279 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1282 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1296
/* 1287 */    MCD::OPC_CheckPredicate, 6, 71, 10, 0, // Skip to: 3923
/* 1292 */    MCD::OPC_Decode, 200, 1, 34, // Opcode: AMOOR_W_RL
/* 1296 */    MCD::OPC_FilterValue, 3, 62, 10, 0, // Skip to: 3923
/* 1301 */    MCD::OPC_CheckPredicate, 7, 57, 10, 0, // Skip to: 3923
/* 1306 */    MCD::OPC_Decode, 196, 1, 34, // Opcode: AMOOR_D_RL
/* 1310 */    MCD::OPC_FilterValue, 34, 31, 0, 0, // Skip to: 1346
/* 1315 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1318 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1332
/* 1323 */    MCD::OPC_CheckPredicate, 6, 35, 10, 0, // Skip to: 3923
/* 1328 */    MCD::OPC_Decode, 198, 1, 34, // Opcode: AMOOR_W_AQ
/* 1332 */    MCD::OPC_FilterValue, 3, 26, 10, 0, // Skip to: 3923
/* 1337 */    MCD::OPC_CheckPredicate, 7, 21, 10, 0, // Skip to: 3923
/* 1342 */    MCD::OPC_Decode, 194, 1, 34, // Opcode: AMOOR_D_AQ
/* 1346 */    MCD::OPC_FilterValue, 35, 31, 0, 0, // Skip to: 1382
/* 1351 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1354 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1368
/* 1359 */    MCD::OPC_CheckPredicate, 6, 255, 9, 0, // Skip to: 3923
/* 1364 */    MCD::OPC_Decode, 199, 1, 34, // Opcode: AMOOR_W_AQ_RL
/* 1368 */    MCD::OPC_FilterValue, 3, 246, 9, 0, // Skip to: 3923
/* 1373 */    MCD::OPC_CheckPredicate, 7, 241, 9, 0, // Skip to: 3923
/* 1378 */    MCD::OPC_Decode, 195, 1, 34, // Opcode: AMOOR_D_AQ_RL
/* 1382 */    MCD::OPC_FilterValue, 48, 31, 0, 0, // Skip to: 1418
/* 1387 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1390 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1404
/* 1395 */    MCD::OPC_CheckPredicate, 6, 219, 9, 0, // Skip to: 3923
/* 1400 */    MCD::OPC_Decode, 157, 1, 34, // Opcode: AMOAND_W
/* 1404 */    MCD::OPC_FilterValue, 3, 210, 9, 0, // Skip to: 3923
/* 1409 */    MCD::OPC_CheckPredicate, 7, 205, 9, 0, // Skip to: 3923
/* 1414 */    MCD::OPC_Decode, 153, 1, 34, // Opcode: AMOAND_D
/* 1418 */    MCD::OPC_FilterValue, 49, 31, 0, 0, // Skip to: 1454
/* 1423 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1426 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1440
/* 1431 */    MCD::OPC_CheckPredicate, 6, 183, 9, 0, // Skip to: 3923
/* 1436 */    MCD::OPC_Decode, 160, 1, 34, // Opcode: AMOAND_W_RL
/* 1440 */    MCD::OPC_FilterValue, 3, 174, 9, 0, // Skip to: 3923
/* 1445 */    MCD::OPC_CheckPredicate, 7, 169, 9, 0, // Skip to: 3923
/* 1450 */    MCD::OPC_Decode, 156, 1, 34, // Opcode: AMOAND_D_RL
/* 1454 */    MCD::OPC_FilterValue, 50, 31, 0, 0, // Skip to: 1490
/* 1459 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1462 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1476
/* 1467 */    MCD::OPC_CheckPredicate, 6, 147, 9, 0, // Skip to: 3923
/* 1472 */    MCD::OPC_Decode, 158, 1, 34, // Opcode: AMOAND_W_AQ
/* 1476 */    MCD::OPC_FilterValue, 3, 138, 9, 0, // Skip to: 3923
/* 1481 */    MCD::OPC_CheckPredicate, 7, 133, 9, 0, // Skip to: 3923
/* 1486 */    MCD::OPC_Decode, 154, 1, 34, // Opcode: AMOAND_D_AQ
/* 1490 */    MCD::OPC_FilterValue, 51, 31, 0, 0, // Skip to: 1526
/* 1495 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1498 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1512
/* 1503 */    MCD::OPC_CheckPredicate, 6, 111, 9, 0, // Skip to: 3923
/* 1508 */    MCD::OPC_Decode, 159, 1, 34, // Opcode: AMOAND_W_AQ_RL
/* 1512 */    MCD::OPC_FilterValue, 3, 102, 9, 0, // Skip to: 3923
/* 1517 */    MCD::OPC_CheckPredicate, 7, 97, 9, 0, // Skip to: 3923
/* 1522 */    MCD::OPC_Decode, 155, 1, 34, // Opcode: AMOAND_D_AQ_RL
/* 1526 */    MCD::OPC_FilterValue, 64, 31, 0, 0, // Skip to: 1562
/* 1531 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1534 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1548
/* 1539 */    MCD::OPC_CheckPredicate, 6, 75, 9, 0, // Skip to: 3923
/* 1544 */    MCD::OPC_Decode, 189, 1, 34, // Opcode: AMOMIN_W
/* 1548 */    MCD::OPC_FilterValue, 3, 66, 9, 0, // Skip to: 3923
/* 1553 */    MCD::OPC_CheckPredicate, 7, 61, 9, 0, // Skip to: 3923
/* 1558 */    MCD::OPC_Decode, 185, 1, 34, // Opcode: AMOMIN_D
/* 1562 */    MCD::OPC_FilterValue, 65, 31, 0, 0, // Skip to: 1598
/* 1567 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1570 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1584
/* 1575 */    MCD::OPC_CheckPredicate, 6, 39, 9, 0, // Skip to: 3923
/* 1580 */    MCD::OPC_Decode, 192, 1, 34, // Opcode: AMOMIN_W_RL
/* 1584 */    MCD::OPC_FilterValue, 3, 30, 9, 0, // Skip to: 3923
/* 1589 */    MCD::OPC_CheckPredicate, 7, 25, 9, 0, // Skip to: 3923
/* 1594 */    MCD::OPC_Decode, 188, 1, 34, // Opcode: AMOMIN_D_RL
/* 1598 */    MCD::OPC_FilterValue, 66, 31, 0, 0, // Skip to: 1634
/* 1603 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1606 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1620
/* 1611 */    MCD::OPC_CheckPredicate, 6, 3, 9, 0, // Skip to: 3923
/* 1616 */    MCD::OPC_Decode, 190, 1, 34, // Opcode: AMOMIN_W_AQ
/* 1620 */    MCD::OPC_FilterValue, 3, 250, 8, 0, // Skip to: 3923
/* 1625 */    MCD::OPC_CheckPredicate, 7, 245, 8, 0, // Skip to: 3923
/* 1630 */    MCD::OPC_Decode, 186, 1, 34, // Opcode: AMOMIN_D_AQ
/* 1634 */    MCD::OPC_FilterValue, 67, 31, 0, 0, // Skip to: 1670
/* 1639 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1642 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1656
/* 1647 */    MCD::OPC_CheckPredicate, 6, 223, 8, 0, // Skip to: 3923
/* 1652 */    MCD::OPC_Decode, 191, 1, 34, // Opcode: AMOMIN_W_AQ_RL
/* 1656 */    MCD::OPC_FilterValue, 3, 214, 8, 0, // Skip to: 3923
/* 1661 */    MCD::OPC_CheckPredicate, 7, 209, 8, 0, // Skip to: 3923
/* 1666 */    MCD::OPC_Decode, 187, 1, 34, // Opcode: AMOMIN_D_AQ_RL
/* 1670 */    MCD::OPC_FilterValue, 80, 31, 0, 0, // Skip to: 1706
/* 1675 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1678 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1692
/* 1683 */    MCD::OPC_CheckPredicate, 6, 187, 8, 0, // Skip to: 3923
/* 1688 */    MCD::OPC_Decode, 173, 1, 34, // Opcode: AMOMAX_W
/* 1692 */    MCD::OPC_FilterValue, 3, 178, 8, 0, // Skip to: 3923
/* 1697 */    MCD::OPC_CheckPredicate, 7, 173, 8, 0, // Skip to: 3923
/* 1702 */    MCD::OPC_Decode, 169, 1, 34, // Opcode: AMOMAX_D
/* 1706 */    MCD::OPC_FilterValue, 81, 31, 0, 0, // Skip to: 1742
/* 1711 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1714 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1728
/* 1719 */    MCD::OPC_CheckPredicate, 6, 151, 8, 0, // Skip to: 3923
/* 1724 */    MCD::OPC_Decode, 176, 1, 34, // Opcode: AMOMAX_W_RL
/* 1728 */    MCD::OPC_FilterValue, 3, 142, 8, 0, // Skip to: 3923
/* 1733 */    MCD::OPC_CheckPredicate, 7, 137, 8, 0, // Skip to: 3923
/* 1738 */    MCD::OPC_Decode, 172, 1, 34, // Opcode: AMOMAX_D_RL
/* 1742 */    MCD::OPC_FilterValue, 82, 31, 0, 0, // Skip to: 1778
/* 1747 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1750 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1764
/* 1755 */    MCD::OPC_CheckPredicate, 6, 115, 8, 0, // Skip to: 3923
/* 1760 */    MCD::OPC_Decode, 174, 1, 34, // Opcode: AMOMAX_W_AQ
/* 1764 */    MCD::OPC_FilterValue, 3, 106, 8, 0, // Skip to: 3923
/* 1769 */    MCD::OPC_CheckPredicate, 7, 101, 8, 0, // Skip to: 3923
/* 1774 */    MCD::OPC_Decode, 170, 1, 34, // Opcode: AMOMAX_D_AQ
/* 1778 */    MCD::OPC_FilterValue, 83, 31, 0, 0, // Skip to: 1814
/* 1783 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1786 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1800
/* 1791 */    MCD::OPC_CheckPredicate, 6, 79, 8, 0, // Skip to: 3923
/* 1796 */    MCD::OPC_Decode, 175, 1, 34, // Opcode: AMOMAX_W_AQ_RL
/* 1800 */    MCD::OPC_FilterValue, 3, 70, 8, 0, // Skip to: 3923
/* 1805 */    MCD::OPC_CheckPredicate, 7, 65, 8, 0, // Skip to: 3923
/* 1810 */    MCD::OPC_Decode, 171, 1, 34, // Opcode: AMOMAX_D_AQ_RL
/* 1814 */    MCD::OPC_FilterValue, 96, 31, 0, 0, // Skip to: 1850
/* 1819 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1822 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1836
/* 1827 */    MCD::OPC_CheckPredicate, 6, 43, 8, 0, // Skip to: 3923
/* 1832 */    MCD::OPC_Decode, 181, 1, 34, // Opcode: AMOMINU_W
/* 1836 */    MCD::OPC_FilterValue, 3, 34, 8, 0, // Skip to: 3923
/* 1841 */    MCD::OPC_CheckPredicate, 7, 29, 8, 0, // Skip to: 3923
/* 1846 */    MCD::OPC_Decode, 177, 1, 34, // Opcode: AMOMINU_D
/* 1850 */    MCD::OPC_FilterValue, 97, 31, 0, 0, // Skip to: 1886
/* 1855 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1858 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1872
/* 1863 */    MCD::OPC_CheckPredicate, 6, 7, 8, 0, // Skip to: 3923
/* 1868 */    MCD::OPC_Decode, 184, 1, 34, // Opcode: AMOMINU_W_RL
/* 1872 */    MCD::OPC_FilterValue, 3, 254, 7, 0, // Skip to: 3923
/* 1877 */    MCD::OPC_CheckPredicate, 7, 249, 7, 0, // Skip to: 3923
/* 1882 */    MCD::OPC_Decode, 180, 1, 34, // Opcode: AMOMINU_D_RL
/* 1886 */    MCD::OPC_FilterValue, 98, 31, 0, 0, // Skip to: 1922
/* 1891 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1894 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1908
/* 1899 */    MCD::OPC_CheckPredicate, 6, 227, 7, 0, // Skip to: 3923
/* 1904 */    MCD::OPC_Decode, 182, 1, 34, // Opcode: AMOMINU_W_AQ
/* 1908 */    MCD::OPC_FilterValue, 3, 218, 7, 0, // Skip to: 3923
/* 1913 */    MCD::OPC_CheckPredicate, 7, 213, 7, 0, // Skip to: 3923
/* 1918 */    MCD::OPC_Decode, 178, 1, 34, // Opcode: AMOMINU_D_AQ
/* 1922 */    MCD::OPC_FilterValue, 99, 31, 0, 0, // Skip to: 1958
/* 1927 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1930 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1944
/* 1935 */    MCD::OPC_CheckPredicate, 6, 191, 7, 0, // Skip to: 3923
/* 1940 */    MCD::OPC_Decode, 183, 1, 34, // Opcode: AMOMINU_W_AQ_RL
/* 1944 */    MCD::OPC_FilterValue, 3, 182, 7, 0, // Skip to: 3923
/* 1949 */    MCD::OPC_CheckPredicate, 7, 177, 7, 0, // Skip to: 3923
/* 1954 */    MCD::OPC_Decode, 179, 1, 34, // Opcode: AMOMINU_D_AQ_RL
/* 1958 */    MCD::OPC_FilterValue, 112, 31, 0, 0, // Skip to: 1994
/* 1963 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1966 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1980
/* 1971 */    MCD::OPC_CheckPredicate, 6, 155, 7, 0, // Skip to: 3923
/* 1976 */    MCD::OPC_Decode, 165, 1, 34, // Opcode: AMOMAXU_W
/* 1980 */    MCD::OPC_FilterValue, 3, 146, 7, 0, // Skip to: 3923
/* 1985 */    MCD::OPC_CheckPredicate, 7, 141, 7, 0, // Skip to: 3923
/* 1990 */    MCD::OPC_Decode, 161, 1, 34, // Opcode: AMOMAXU_D
/* 1994 */    MCD::OPC_FilterValue, 113, 31, 0, 0, // Skip to: 2030
/* 1999 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2002 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2016
/* 2007 */    MCD::OPC_CheckPredicate, 6, 119, 7, 0, // Skip to: 3923
/* 2012 */    MCD::OPC_Decode, 168, 1, 34, // Opcode: AMOMAXU_W_RL
/* 2016 */    MCD::OPC_FilterValue, 3, 110, 7, 0, // Skip to: 3923
/* 2021 */    MCD::OPC_CheckPredicate, 7, 105, 7, 0, // Skip to: 3923
/* 2026 */    MCD::OPC_Decode, 164, 1, 34, // Opcode: AMOMAXU_D_RL
/* 2030 */    MCD::OPC_FilterValue, 114, 31, 0, 0, // Skip to: 2066
/* 2035 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2038 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2052
/* 2043 */    MCD::OPC_CheckPredicate, 6, 83, 7, 0, // Skip to: 3923
/* 2048 */    MCD::OPC_Decode, 166, 1, 34, // Opcode: AMOMAXU_W_AQ
/* 2052 */    MCD::OPC_FilterValue, 3, 74, 7, 0, // Skip to: 3923
/* 2057 */    MCD::OPC_CheckPredicate, 7, 69, 7, 0, // Skip to: 3923
/* 2062 */    MCD::OPC_Decode, 162, 1, 34, // Opcode: AMOMAXU_D_AQ
/* 2066 */    MCD::OPC_FilterValue, 115, 60, 7, 0, // Skip to: 3923
/* 2071 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2074 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2088
/* 2079 */    MCD::OPC_CheckPredicate, 6, 47, 7, 0, // Skip to: 3923
/* 2084 */    MCD::OPC_Decode, 167, 1, 34, // Opcode: AMOMAXU_W_AQ_RL
/* 2088 */    MCD::OPC_FilterValue, 3, 38, 7, 0, // Skip to: 3923
/* 2093 */    MCD::OPC_CheckPredicate, 7, 33, 7, 0, // Skip to: 3923
/* 2098 */    MCD::OPC_Decode, 163, 1, 34, // Opcode: AMOMAXU_D_AQ_RL
/* 2102 */    MCD::OPC_FilterValue, 51, 13, 1, 0, // Skip to: 2376
/* 2107 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2110 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 2150
/* 2115 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2118 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2127
/* 2123 */    MCD::OPC_Decode, 141, 1, 34, // Opcode: ADD
/* 2127 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2141
/* 2132 */    MCD::OPC_CheckPredicate, 8, 250, 6, 0, // Skip to: 3923
/* 2137 */    MCD::OPC_Decode, 236, 2, 34, // Opcode: MUL
/* 2141 */    MCD::OPC_FilterValue, 32, 241, 6, 0, // Skip to: 3923
/* 2146 */    MCD::OPC_Decode, 148, 3, 34, // Opcode: SUB
/* 2150 */    MCD::OPC_FilterValue, 1, 26, 0, 0, // Skip to: 2181
/* 2155 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2158 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2167
/* 2163 */    MCD::OPC_Decode, 131, 3, 34, // Opcode: SLL
/* 2167 */    MCD::OPC_FilterValue, 1, 215, 6, 0, // Skip to: 3923
/* 2172 */    MCD::OPC_CheckPredicate, 8, 210, 6, 0, // Skip to: 3923
/* 2177 */    MCD::OPC_Decode, 237, 2, 34, // Opcode: MULH
/* 2181 */    MCD::OPC_FilterValue, 2, 26, 0, 0, // Skip to: 2212
/* 2186 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2189 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2198
/* 2194 */    MCD::OPC_Decode, 135, 3, 34, // Opcode: SLT
/* 2198 */    MCD::OPC_FilterValue, 1, 184, 6, 0, // Skip to: 3923
/* 2203 */    MCD::OPC_CheckPredicate, 8, 179, 6, 0, // Skip to: 3923
/* 2208 */    MCD::OPC_Decode, 238, 2, 34, // Opcode: MULHSU
/* 2212 */    MCD::OPC_FilterValue, 3, 26, 0, 0, // Skip to: 2243
/* 2217 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2220 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2229
/* 2225 */    MCD::OPC_Decode, 138, 3, 34, // Opcode: SLTU
/* 2229 */    MCD::OPC_FilterValue, 1, 153, 6, 0, // Skip to: 3923
/* 2234 */    MCD::OPC_CheckPredicate, 8, 148, 6, 0, // Skip to: 3923
/* 2239 */    MCD::OPC_Decode, 239, 2, 34, // Opcode: MULHU
/* 2243 */    MCD::OPC_FilterValue, 4, 26, 0, 0, // Skip to: 2274
/* 2248 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2251 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2260
/* 2256 */    MCD::OPC_Decode, 153, 3, 34, // Opcode: XOR
/* 2260 */    MCD::OPC_FilterValue, 1, 122, 6, 0, // Skip to: 3923
/* 2265 */    MCD::OPC_CheckPredicate, 8, 117, 6, 0, // Skip to: 3923
/* 2270 */    MCD::OPC_Decode, 146, 2, 34, // Opcode: DIV
/* 2274 */    MCD::OPC_FilterValue, 5, 35, 0, 0, // Skip to: 2314
/* 2279 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2282 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2291
/* 2287 */    MCD::OPC_Decode, 144, 3, 34, // Opcode: SRL
/* 2291 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2305
/* 2296 */    MCD::OPC_CheckPredicate, 8, 86, 6, 0, // Skip to: 3923
/* 2301 */    MCD::OPC_Decode, 147, 2, 34, // Opcode: DIVU
/* 2305 */    MCD::OPC_FilterValue, 32, 77, 6, 0, // Skip to: 3923
/* 2310 */    MCD::OPC_Decode, 139, 3, 34, // Opcode: SRA
/* 2314 */    MCD::OPC_FilterValue, 6, 26, 0, 0, // Skip to: 2345
/* 2319 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2322 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2331
/* 2327 */    MCD::OPC_Decode, 241, 2, 34, // Opcode: OR
/* 2331 */    MCD::OPC_FilterValue, 1, 51, 6, 0, // Skip to: 3923
/* 2336 */    MCD::OPC_CheckPredicate, 8, 46, 6, 0, // Skip to: 3923
/* 2341 */    MCD::OPC_Decode, 243, 2, 34, // Opcode: REM
/* 2345 */    MCD::OPC_FilterValue, 7, 37, 6, 0, // Skip to: 3923
/* 2350 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2353 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2362
/* 2358 */    MCD::OPC_Decode, 217, 1, 34, // Opcode: AND
/* 2362 */    MCD::OPC_FilterValue, 1, 20, 6, 0, // Skip to: 3923
/* 2367 */    MCD::OPC_CheckPredicate, 8, 15, 6, 0, // Skip to: 3923
/* 2372 */    MCD::OPC_Decode, 244, 2, 34, // Opcode: REMU
/* 2376 */    MCD::OPC_FilterValue, 55, 4, 0, 0, // Skip to: 2385
/* 2381 */    MCD::OPC_Decode, 232, 2, 29, // Opcode: LUI
/* 2385 */    MCD::OPC_FilterValue, 59, 187, 0, 0, // Skip to: 2577
/* 2390 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2393 */    MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 2443
/* 2398 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2401 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2415
/* 2406 */    MCD::OPC_CheckPredicate, 3, 232, 5, 0, // Skip to: 3923
/* 2411 */    MCD::OPC_Decode, 144, 1, 34, // Opcode: ADDW
/* 2415 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2429
/* 2420 */    MCD::OPC_CheckPredicate, 9, 218, 5, 0, // Skip to: 3923
/* 2425 */    MCD::OPC_Decode, 240, 2, 34, // Opcode: MULW
/* 2429 */    MCD::OPC_FilterValue, 32, 209, 5, 0, // Skip to: 3923
/* 2434 */    MCD::OPC_CheckPredicate, 3, 204, 5, 0, // Skip to: 3923
/* 2439 */    MCD::OPC_Decode, 149, 3, 34, // Opcode: SUBW
/* 2443 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 2464
/* 2448 */    MCD::OPC_CheckPredicate, 3, 190, 5, 0, // Skip to: 3923
/* 2453 */    MCD::OPC_CheckField, 25, 7, 0, 183, 5, 0, // Skip to: 3923
/* 2460 */    MCD::OPC_Decode, 134, 3, 34, // Opcode: SLLW
/* 2464 */    MCD::OPC_FilterValue, 4, 16, 0, 0, // Skip to: 2485
/* 2469 */    MCD::OPC_CheckPredicate, 9, 169, 5, 0, // Skip to: 3923
/* 2474 */    MCD::OPC_CheckField, 25, 7, 1, 162, 5, 0, // Skip to: 3923
/* 2481 */    MCD::OPC_Decode, 149, 2, 34, // Opcode: DIVW
/* 2485 */    MCD::OPC_FilterValue, 5, 45, 0, 0, // Skip to: 2535
/* 2490 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2493 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2507
/* 2498 */    MCD::OPC_CheckPredicate, 3, 140, 5, 0, // Skip to: 3923
/* 2503 */    MCD::OPC_Decode, 147, 3, 34, // Opcode: SRLW
/* 2507 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2521
/* 2512 */    MCD::OPC_CheckPredicate, 9, 126, 5, 0, // Skip to: 3923
/* 2517 */    MCD::OPC_Decode, 148, 2, 34, // Opcode: DIVUW
/* 2521 */    MCD::OPC_FilterValue, 32, 117, 5, 0, // Skip to: 3923
/* 2526 */    MCD::OPC_CheckPredicate, 3, 112, 5, 0, // Skip to: 3923
/* 2531 */    MCD::OPC_Decode, 142, 3, 34, // Opcode: SRAW
/* 2535 */    MCD::OPC_FilterValue, 6, 16, 0, 0, // Skip to: 2556
/* 2540 */    MCD::OPC_CheckPredicate, 9, 98, 5, 0, // Skip to: 3923
/* 2545 */    MCD::OPC_CheckField, 25, 7, 1, 91, 5, 0, // Skip to: 3923
/* 2552 */    MCD::OPC_Decode, 246, 2, 34, // Opcode: REMW
/* 2556 */    MCD::OPC_FilterValue, 7, 82, 5, 0, // Skip to: 3923
/* 2561 */    MCD::OPC_CheckPredicate, 9, 77, 5, 0, // Skip to: 3923
/* 2566 */    MCD::OPC_CheckField, 25, 7, 1, 70, 5, 0, // Skip to: 3923
/* 2573 */    MCD::OPC_Decode, 245, 2, 34, // Opcode: REMUW
/* 2577 */    MCD::OPC_FilterValue, 67, 31, 0, 0, // Skip to: 2613
/* 2582 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 2585 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2599
/* 2590 */    MCD::OPC_CheckPredicate, 4, 48, 5, 0, // Skip to: 3923
/* 2595 */    MCD::OPC_Decode, 188, 2, 36, // Opcode: FMADD_S
/* 2599 */    MCD::OPC_FilterValue, 1, 39, 5, 0, // Skip to: 3923
/* 2604 */    MCD::OPC_CheckPredicate, 5, 34, 5, 0, // Skip to: 3923
/* 2609 */    MCD::OPC_Decode, 187, 2, 37, // Opcode: FMADD_D
/* 2613 */    MCD::OPC_FilterValue, 71, 31, 0, 0, // Skip to: 2649
/* 2618 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 2621 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2635
/* 2626 */    MCD::OPC_CheckPredicate, 4, 12, 5, 0, // Skip to: 3923
/* 2631 */    MCD::OPC_Decode, 194, 2, 36, // Opcode: FMSUB_S
/* 2635 */    MCD::OPC_FilterValue, 1, 3, 5, 0, // Skip to: 3923
/* 2640 */    MCD::OPC_CheckPredicate, 5, 254, 4, 0, // Skip to: 3923
/* 2645 */    MCD::OPC_Decode, 193, 2, 37, // Opcode: FMSUB_D
/* 2649 */    MCD::OPC_FilterValue, 75, 31, 0, 0, // Skip to: 2685
/* 2654 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 2657 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2671
/* 2662 */    MCD::OPC_CheckPredicate, 4, 232, 4, 0, // Skip to: 3923
/* 2667 */    MCD::OPC_Decode, 204, 2, 36, // Opcode: FNMSUB_S
/* 2671 */    MCD::OPC_FilterValue, 1, 223, 4, 0, // Skip to: 3923
/* 2676 */    MCD::OPC_CheckPredicate, 5, 218, 4, 0, // Skip to: 3923
/* 2681 */    MCD::OPC_Decode, 203, 2, 37, // Opcode: FNMSUB_D
/* 2685 */    MCD::OPC_FilterValue, 79, 31, 0, 0, // Skip to: 2721
/* 2690 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 2693 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2707
/* 2698 */    MCD::OPC_CheckPredicate, 4, 196, 4, 0, // Skip to: 3923
/* 2703 */    MCD::OPC_Decode, 202, 2, 36, // Opcode: FNMADD_S
/* 2707 */    MCD::OPC_FilterValue, 1, 187, 4, 0, // Skip to: 3923
/* 2712 */    MCD::OPC_CheckPredicate, 5, 182, 4, 0, // Skip to: 3923
/* 2717 */    MCD::OPC_Decode, 201, 2, 37, // Opcode: FNMADD_D
/* 2721 */    MCD::OPC_FilterValue, 83, 136, 3, 0, // Skip to: 3630
/* 2726 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2729 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2743
/* 2734 */    MCD::OPC_CheckPredicate, 4, 160, 4, 0, // Skip to: 3923
/* 2739 */    MCD::OPC_Decode, 153, 2, 38, // Opcode: FADD_S
/* 2743 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2757
/* 2748 */    MCD::OPC_CheckPredicate, 5, 146, 4, 0, // Skip to: 3923
/* 2753 */    MCD::OPC_Decode, 152, 2, 39, // Opcode: FADD_D
/* 2757 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 2771
/* 2762 */    MCD::OPC_CheckPredicate, 4, 132, 4, 0, // Skip to: 3923
/* 2767 */    MCD::OPC_Decode, 215, 2, 38, // Opcode: FSUB_S
/* 2771 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 2785
/* 2776 */    MCD::OPC_CheckPredicate, 5, 118, 4, 0, // Skip to: 3923
/* 2781 */    MCD::OPC_Decode, 214, 2, 39, // Opcode: FSUB_D
/* 2785 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 2799
/* 2790 */    MCD::OPC_CheckPredicate, 4, 104, 4, 0, // Skip to: 3923
/* 2795 */    MCD::OPC_Decode, 196, 2, 38, // Opcode: FMUL_S
/* 2799 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 2813
/* 2804 */    MCD::OPC_CheckPredicate, 5, 90, 4, 0, // Skip to: 3923
/* 2809 */    MCD::OPC_Decode, 195, 2, 39, // Opcode: FMUL_D
/* 2813 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 2827
/* 2818 */    MCD::OPC_CheckPredicate, 4, 76, 4, 0, // Skip to: 3923
/* 2823 */    MCD::OPC_Decode, 175, 2, 38, // Opcode: FDIV_S
/* 2827 */    MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 2841
/* 2832 */    MCD::OPC_CheckPredicate, 5, 62, 4, 0, // Skip to: 3923
/* 2837 */    MCD::OPC_Decode, 174, 2, 39, // Opcode: FDIV_D
/* 2841 */    MCD::OPC_FilterValue, 16, 45, 0, 0, // Skip to: 2891
/* 2846 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2849 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2863
/* 2854 */    MCD::OPC_CheckPredicate, 4, 40, 4, 0, // Skip to: 3923
/* 2859 */    MCD::OPC_Decode, 211, 2, 40, // Opcode: FSGNJ_S
/* 2863 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2877
/* 2868 */    MCD::OPC_CheckPredicate, 4, 26, 4, 0, // Skip to: 3923
/* 2873 */    MCD::OPC_Decode, 207, 2, 40, // Opcode: FSGNJN_S
/* 2877 */    MCD::OPC_FilterValue, 2, 17, 4, 0, // Skip to: 3923
/* 2882 */    MCD::OPC_CheckPredicate, 4, 12, 4, 0, // Skip to: 3923
/* 2887 */    MCD::OPC_Decode, 209, 2, 40, // Opcode: FSGNJX_S
/* 2891 */    MCD::OPC_FilterValue, 17, 45, 0, 0, // Skip to: 2941
/* 2896 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2899 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2913
/* 2904 */    MCD::OPC_CheckPredicate, 5, 246, 3, 0, // Skip to: 3923
/* 2909 */    MCD::OPC_Decode, 210, 2, 41, // Opcode: FSGNJ_D
/* 2913 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2927
/* 2918 */    MCD::OPC_CheckPredicate, 5, 232, 3, 0, // Skip to: 3923
/* 2923 */    MCD::OPC_Decode, 206, 2, 41, // Opcode: FSGNJN_D
/* 2927 */    MCD::OPC_FilterValue, 2, 223, 3, 0, // Skip to: 3923
/* 2932 */    MCD::OPC_CheckPredicate, 5, 218, 3, 0, // Skip to: 3923
/* 2937 */    MCD::OPC_Decode, 208, 2, 41, // Opcode: FSGNJX_D
/* 2941 */    MCD::OPC_FilterValue, 20, 31, 0, 0, // Skip to: 2977
/* 2946 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2949 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2963
/* 2954 */    MCD::OPC_CheckPredicate, 4, 196, 3, 0, // Skip to: 3923
/* 2959 */    MCD::OPC_Decode, 192, 2, 40, // Opcode: FMIN_S
/* 2963 */    MCD::OPC_FilterValue, 1, 187, 3, 0, // Skip to: 3923
/* 2968 */    MCD::OPC_CheckPredicate, 4, 182, 3, 0, // Skip to: 3923
/* 2973 */    MCD::OPC_Decode, 190, 2, 40, // Opcode: FMAX_S
/* 2977 */    MCD::OPC_FilterValue, 21, 31, 0, 0, // Skip to: 3013
/* 2982 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2985 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2999
/* 2990 */    MCD::OPC_CheckPredicate, 5, 160, 3, 0, // Skip to: 3923
/* 2995 */    MCD::OPC_Decode, 191, 2, 41, // Opcode: FMIN_D
/* 2999 */    MCD::OPC_FilterValue, 1, 151, 3, 0, // Skip to: 3923
/* 3004 */    MCD::OPC_CheckPredicate, 5, 146, 3, 0, // Skip to: 3923
/* 3009 */    MCD::OPC_Decode, 189, 2, 41, // Opcode: FMAX_D
/* 3013 */    MCD::OPC_FilterValue, 32, 16, 0, 0, // Skip to: 3034
/* 3018 */    MCD::OPC_CheckPredicate, 5, 132, 3, 0, // Skip to: 3923
/* 3023 */    MCD::OPC_CheckField, 20, 5, 1, 125, 3, 0, // Skip to: 3923
/* 3030 */    MCD::OPC_Decode, 165, 2, 42, // Opcode: FCVT_S_D
/* 3034 */    MCD::OPC_FilterValue, 33, 23, 0, 0, // Skip to: 3062
/* 3039 */    MCD::OPC_CheckPredicate, 5, 111, 3, 0, // Skip to: 3923
/* 3044 */    MCD::OPC_CheckField, 20, 5, 0, 104, 3, 0, // Skip to: 3923
/* 3051 */    MCD::OPC_CheckField, 12, 3, 0, 97, 3, 0, // Skip to: 3923
/* 3058 */    MCD::OPC_Decode, 158, 2, 43, // Opcode: FCVT_D_S
/* 3062 */    MCD::OPC_FilterValue, 44, 16, 0, 0, // Skip to: 3083
/* 3067 */    MCD::OPC_CheckPredicate, 4, 83, 3, 0, // Skip to: 3923
/* 3072 */    MCD::OPC_CheckField, 20, 5, 0, 76, 3, 0, // Skip to: 3923
/* 3079 */    MCD::OPC_Decode, 213, 2, 44, // Opcode: FSQRT_S
/* 3083 */    MCD::OPC_FilterValue, 45, 16, 0, 0, // Skip to: 3104
/* 3088 */    MCD::OPC_CheckPredicate, 5, 62, 3, 0, // Skip to: 3923
/* 3093 */    MCD::OPC_CheckField, 20, 5, 0, 55, 3, 0, // Skip to: 3923
/* 3100 */    MCD::OPC_Decode, 212, 2, 45, // Opcode: FSQRT_D
/* 3104 */    MCD::OPC_FilterValue, 80, 45, 0, 0, // Skip to: 3154
/* 3109 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 3112 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3126
/* 3117 */    MCD::OPC_CheckPredicate, 4, 33, 3, 0, // Skip to: 3923
/* 3122 */    MCD::OPC_Decode, 183, 2, 46, // Opcode: FLE_S
/* 3126 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3140
/* 3131 */    MCD::OPC_CheckPredicate, 4, 19, 3, 0, // Skip to: 3923
/* 3136 */    MCD::OPC_Decode, 185, 2, 46, // Opcode: FLT_S
/* 3140 */    MCD::OPC_FilterValue, 2, 10, 3, 0, // Skip to: 3923
/* 3145 */    MCD::OPC_CheckPredicate, 4, 5, 3, 0, // Skip to: 3923
/* 3150 */    MCD::OPC_Decode, 180, 2, 46, // Opcode: FEQ_S
/* 3154 */    MCD::OPC_FilterValue, 81, 45, 0, 0, // Skip to: 3204
/* 3159 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 3162 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3176
/* 3167 */    MCD::OPC_CheckPredicate, 5, 239, 2, 0, // Skip to: 3923
/* 3172 */    MCD::OPC_Decode, 182, 2, 47, // Opcode: FLE_D
/* 3176 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3190
/* 3181 */    MCD::OPC_CheckPredicate, 5, 225, 2, 0, // Skip to: 3923
/* 3186 */    MCD::OPC_Decode, 184, 2, 47, // Opcode: FLT_D
/* 3190 */    MCD::OPC_FilterValue, 2, 216, 2, 0, // Skip to: 3923
/* 3195 */    MCD::OPC_CheckPredicate, 5, 211, 2, 0, // Skip to: 3923
/* 3200 */    MCD::OPC_Decode, 179, 2, 47, // Opcode: FEQ_D
/* 3204 */    MCD::OPC_FilterValue, 96, 59, 0, 0, // Skip to: 3268
/* 3209 */    MCD::OPC_ExtractField, 20, 5,  // Inst{24-20} ...
/* 3212 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3226
/* 3217 */    MCD::OPC_CheckPredicate, 4, 189, 2, 0, // Skip to: 3923
/* 3222 */    MCD::OPC_Decode, 173, 2, 48, // Opcode: FCVT_W_S
/* 3226 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3240
/* 3231 */    MCD::OPC_CheckPredicate, 4, 175, 2, 0, // Skip to: 3923
/* 3236 */    MCD::OPC_Decode, 171, 2, 48, // Opcode: FCVT_WU_S
/* 3240 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3254
/* 3245 */    MCD::OPC_CheckPredicate, 10, 161, 2, 0, // Skip to: 3923
/* 3250 */    MCD::OPC_Decode, 164, 2, 48, // Opcode: FCVT_L_S
/* 3254 */    MCD::OPC_FilterValue, 3, 152, 2, 0, // Skip to: 3923
/* 3259 */    MCD::OPC_CheckPredicate, 10, 147, 2, 0, // Skip to: 3923
/* 3264 */    MCD::OPC_Decode, 162, 2, 48, // Opcode: FCVT_LU_S
/* 3268 */    MCD::OPC_FilterValue, 97, 59, 0, 0, // Skip to: 3332
/* 3273 */    MCD::OPC_ExtractField, 20, 5,  // Inst{24-20} ...
/* 3276 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3290
/* 3281 */    MCD::OPC_CheckPredicate, 5, 125, 2, 0, // Skip to: 3923
/* 3286 */    MCD::OPC_Decode, 172, 2, 49, // Opcode: FCVT_W_D
/* 3290 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3304
/* 3295 */    MCD::OPC_CheckPredicate, 5, 111, 2, 0, // Skip to: 3923
/* 3300 */    MCD::OPC_Decode, 170, 2, 49, // Opcode: FCVT_WU_D
/* 3304 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3318
/* 3309 */    MCD::OPC_CheckPredicate, 11, 97, 2, 0, // Skip to: 3923
/* 3314 */    MCD::OPC_Decode, 163, 2, 49, // Opcode: FCVT_L_D
/* 3318 */    MCD::OPC_FilterValue, 3, 88, 2, 0, // Skip to: 3923
/* 3323 */    MCD::OPC_CheckPredicate, 11, 83, 2, 0, // Skip to: 3923
/* 3328 */    MCD::OPC_Decode, 161, 2, 49, // Opcode: FCVT_LU_D
/* 3332 */    MCD::OPC_FilterValue, 104, 59, 0, 0, // Skip to: 3396
/* 3337 */    MCD::OPC_ExtractField, 20, 5,  // Inst{24-20} ...
/* 3340 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3354
/* 3345 */    MCD::OPC_CheckPredicate, 4, 61, 2, 0, // Skip to: 3923
/* 3350 */    MCD::OPC_Decode, 168, 2, 50, // Opcode: FCVT_S_W
/* 3354 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3368
/* 3359 */    MCD::OPC_CheckPredicate, 4, 47, 2, 0, // Skip to: 3923
/* 3364 */    MCD::OPC_Decode, 169, 2, 50, // Opcode: FCVT_S_WU
/* 3368 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3382
/* 3373 */    MCD::OPC_CheckPredicate, 10, 33, 2, 0, // Skip to: 3923
/* 3378 */    MCD::OPC_Decode, 166, 2, 50, // Opcode: FCVT_S_L
/* 3382 */    MCD::OPC_FilterValue, 3, 24, 2, 0, // Skip to: 3923
/* 3387 */    MCD::OPC_CheckPredicate, 10, 19, 2, 0, // Skip to: 3923
/* 3392 */    MCD::OPC_Decode, 167, 2, 50, // Opcode: FCVT_S_LU
/* 3396 */    MCD::OPC_FilterValue, 105, 73, 0, 0, // Skip to: 3474
/* 3401 */    MCD::OPC_ExtractField, 20, 5,  // Inst{24-20} ...
/* 3404 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3425
/* 3409 */    MCD::OPC_CheckPredicate, 5, 253, 1, 0, // Skip to: 3923
/* 3414 */    MCD::OPC_CheckField, 12, 3, 0, 246, 1, 0, // Skip to: 3923
/* 3421 */    MCD::OPC_Decode, 159, 2, 51, // Opcode: FCVT_D_W
/* 3425 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 3446
/* 3430 */    MCD::OPC_CheckPredicate, 5, 232, 1, 0, // Skip to: 3923
/* 3435 */    MCD::OPC_CheckField, 12, 3, 0, 225, 1, 0, // Skip to: 3923
/* 3442 */    MCD::OPC_Decode, 160, 2, 51, // Opcode: FCVT_D_WU
/* 3446 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3460
/* 3451 */    MCD::OPC_CheckPredicate, 11, 211, 1, 0, // Skip to: 3923
/* 3456 */    MCD::OPC_Decode, 156, 2, 52, // Opcode: FCVT_D_L
/* 3460 */    MCD::OPC_FilterValue, 3, 202, 1, 0, // Skip to: 3923
/* 3465 */    MCD::OPC_CheckPredicate, 11, 197, 1, 0, // Skip to: 3923
/* 3470 */    MCD::OPC_Decode, 157, 2, 52, // Opcode: FCVT_D_LU
/* 3474 */    MCD::OPC_FilterValue, 112, 45, 0, 0, // Skip to: 3524
/* 3479 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 3482 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3503
/* 3487 */    MCD::OPC_CheckPredicate, 4, 175, 1, 0, // Skip to: 3923
/* 3492 */    MCD::OPC_CheckField, 20, 5, 0, 168, 1, 0, // Skip to: 3923
/* 3499 */    MCD::OPC_Decode, 200, 2, 53, // Opcode: FMV_X_W
/* 3503 */    MCD::OPC_FilterValue, 1, 159, 1, 0, // Skip to: 3923
/* 3508 */    MCD::OPC_CheckPredicate, 4, 154, 1, 0, // Skip to: 3923
/* 3513 */    MCD::OPC_CheckField, 20, 5, 0, 147, 1, 0, // Skip to: 3923
/* 3520 */    MCD::OPC_Decode, 155, 2, 53, // Opcode: FCLASS_S
/* 3524 */    MCD::OPC_FilterValue, 113, 45, 0, 0, // Skip to: 3574
/* 3529 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 3532 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3553
/* 3537 */    MCD::OPC_CheckPredicate, 11, 125, 1, 0, // Skip to: 3923
/* 3542 */    MCD::OPC_CheckField, 20, 5, 0, 118, 1, 0, // Skip to: 3923
/* 3549 */    MCD::OPC_Decode, 199, 2, 54, // Opcode: FMV_X_D
/* 3553 */    MCD::OPC_FilterValue, 1, 109, 1, 0, // Skip to: 3923
/* 3558 */    MCD::OPC_CheckPredicate, 5, 104, 1, 0, // Skip to: 3923
/* 3563 */    MCD::OPC_CheckField, 20, 5, 0, 97, 1, 0, // Skip to: 3923
/* 3570 */    MCD::OPC_Decode, 154, 2, 54, // Opcode: FCLASS_D
/* 3574 */    MCD::OPC_FilterValue, 120, 23, 0, 0, // Skip to: 3602
/* 3579 */    MCD::OPC_CheckPredicate, 4, 83, 1, 0, // Skip to: 3923
/* 3584 */    MCD::OPC_CheckField, 20, 5, 0, 76, 1, 0, // Skip to: 3923
/* 3591 */    MCD::OPC_CheckField, 12, 3, 0, 69, 1, 0, // Skip to: 3923
/* 3598 */    MCD::OPC_Decode, 198, 2, 55, // Opcode: FMV_W_X
/* 3602 */    MCD::OPC_FilterValue, 121, 60, 1, 0, // Skip to: 3923
/* 3607 */    MCD::OPC_CheckPredicate, 11, 55, 1, 0, // Skip to: 3923
/* 3612 */    MCD::OPC_CheckField, 20, 5, 0, 48, 1, 0, // Skip to: 3923
/* 3619 */    MCD::OPC_CheckField, 12, 3, 0, 41, 1, 0, // Skip to: 3923
/* 3626 */    MCD::OPC_Decode, 197, 2, 51, // Opcode: FMV_D_X
/* 3630 */    MCD::OPC_FilterValue, 99, 57, 0, 0, // Skip to: 3692
/* 3635 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 3638 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3647
/* 3643 */    MCD::OPC_Decode, 220, 1, 56, // Opcode: BEQ
/* 3647 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3656
/* 3652 */    MCD::OPC_Decode, 225, 1, 56, // Opcode: BNE
/* 3656 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 3665
/* 3661 */    MCD::OPC_Decode, 223, 1, 56, // Opcode: BLT
/* 3665 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 3674
/* 3670 */    MCD::OPC_Decode, 221, 1, 56, // Opcode: BGE
/* 3674 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 3683
/* 3679 */    MCD::OPC_Decode, 224, 1, 56, // Opcode: BLTU
/* 3683 */    MCD::OPC_FilterValue, 7, 235, 0, 0, // Skip to: 3923
/* 3688 */    MCD::OPC_Decode, 222, 1, 56, // Opcode: BGEU
/* 3692 */    MCD::OPC_FilterValue, 103, 11, 0, 0, // Skip to: 3708
/* 3697 */    MCD::OPC_CheckField, 12, 3, 0, 219, 0, 0, // Skip to: 3923
/* 3704 */    MCD::OPC_Decode, 218, 2, 24, // Opcode: JALR
/* 3708 */    MCD::OPC_FilterValue, 111, 4, 0, 0, // Skip to: 3717
/* 3713 */    MCD::OPC_Decode, 217, 2, 57, // Opcode: JAL
/* 3717 */    MCD::OPC_FilterValue, 115, 201, 0, 0, // Skip to: 3923
/* 3722 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 3725 */    MCD::OPC_FilterValue, 0, 139, 0, 0, // Skip to: 3869
/* 3730 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 3733 */    MCD::OPC_FilterValue, 0, 51, 0, 0, // Skip to: 3789
/* 3738 */    MCD::OPC_ExtractField, 15, 10,  // Inst{24-15} ...
/* 3741 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3757
/* 3746 */    MCD::OPC_CheckField, 7, 5, 0, 170, 0, 0, // Skip to: 3923
/* 3753 */    MCD::OPC_Decode, 151, 2, 1, // Opcode: ECALL
/* 3757 */    MCD::OPC_FilterValue, 32, 11, 0, 0, // Skip to: 3773
/* 3762 */    MCD::OPC_CheckField, 7, 5, 0, 154, 0, 0, // Skip to: 3923
/* 3769 */    MCD::OPC_Decode, 150, 2, 1, // Opcode: EBREAK
/* 3773 */    MCD::OPC_FilterValue, 64, 145, 0, 0, // Skip to: 3923
/* 3778 */    MCD::OPC_CheckField, 7, 5, 0, 138, 0, 0, // Skip to: 3923
/* 3785 */    MCD::OPC_Decode, 151, 3, 1, // Opcode: URET
/* 3789 */    MCD::OPC_FilterValue, 8, 36, 0, 0, // Skip to: 3830
/* 3794 */    MCD::OPC_ExtractField, 15, 10,  // Inst{24-15} ...
/* 3797 */    MCD::OPC_FilterValue, 64, 11, 0, 0, // Skip to: 3813
/* 3802 */    MCD::OPC_CheckField, 7, 5, 0, 114, 0, 0, // Skip to: 3923
/* 3809 */    MCD::OPC_Decode, 143, 3, 1, // Opcode: SRET
/* 3813 */    MCD::OPC_FilterValue, 160, 1, 104, 0, 0, // Skip to: 3923
/* 3819 */    MCD::OPC_CheckField, 7, 5, 0, 97, 0, 0, // Skip to: 3923
/* 3826 */    MCD::OPC_Decode, 152, 3, 1, // Opcode: WFI
/* 3830 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 3846
/* 3835 */    MCD::OPC_CheckField, 7, 5, 0, 81, 0, 0, // Skip to: 3923
/* 3842 */    MCD::OPC_Decode, 129, 3, 58, // Opcode: SFENCE_VMA
/* 3846 */    MCD::OPC_FilterValue, 24, 72, 0, 0, // Skip to: 3923
/* 3851 */    MCD::OPC_CheckField, 15, 10, 64, 65, 0, 0, // Skip to: 3923
/* 3858 */    MCD::OPC_CheckField, 7, 5, 0, 58, 0, 0, // Skip to: 3923
/* 3865 */    MCD::OPC_Decode, 235, 2, 1, // Opcode: MRET
/* 3869 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3878
/* 3874 */    MCD::OPC_Decode, 230, 1, 59, // Opcode: CSRRW
/* 3878 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3887
/* 3883 */    MCD::OPC_Decode, 228, 1, 59, // Opcode: CSRRS
/* 3887 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 3896
/* 3892 */    MCD::OPC_Decode, 226, 1, 59, // Opcode: CSRRC
/* 3896 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 3905
/* 3901 */    MCD::OPC_Decode, 231, 1, 60, // Opcode: CSRRWI
/* 3905 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 3914
/* 3910 */    MCD::OPC_Decode, 229, 1, 60, // Opcode: CSRRSI
/* 3914 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 3923
/* 3919 */    MCD::OPC_Decode, 227, 1, 60, // Opcode: CSRRCI
/* 3923 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableRISCV32Only_16[] = {
/* 0 */       MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 3 */       MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 39
/* 8 */       MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 11 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 25
/* 16 */      MCD::OPC_CheckPredicate, 12, 75, 0, 0, // Skip to: 96
/* 21 */      MCD::OPC_Decode, 245, 1, 61, // Opcode: C_FLW
/* 25 */      MCD::OPC_FilterValue, 7, 66, 0, 0, // Skip to: 96
/* 30 */      MCD::OPC_CheckPredicate, 12, 61, 0, 0, // Skip to: 96
/* 35 */      MCD::OPC_Decode, 249, 1, 61, // Opcode: C_FSW
/* 39 */      MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 60
/* 44 */      MCD::OPC_CheckPredicate, 13, 47, 0, 0, // Skip to: 96
/* 49 */      MCD::OPC_CheckField, 13, 3, 1, 40, 0, 0, // Skip to: 96
/* 56 */      MCD::OPC_Decode, 252, 1, 19, // Opcode: C_JAL
/* 60 */      MCD::OPC_FilterValue, 2, 31, 0, 0, // Skip to: 96
/* 65 */      MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 68 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 82
/* 73 */      MCD::OPC_CheckPredicate, 12, 18, 0, 0, // Skip to: 96
/* 78 */      MCD::OPC_Decode, 246, 1, 62, // Opcode: C_FLWSP
/* 82 */      MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 96
/* 87 */      MCD::OPC_CheckPredicate, 12, 4, 0, 0, // Skip to: 96
/* 92 */      MCD::OPC_Decode, 250, 1, 63, // Opcode: C_FSWSP
/* 96 */      MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset& Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[RISCV::FeatureStdExtC]);
  case 1:
    return (Bits[RISCV::FeatureStdExtC] && Bits[RISCV::FeatureStdExtD]);
  case 2:
    return (Bits[RISCV::FeatureStdExtC] && Bits[RISCV::Feature64Bit]);
  case 3:
    return (Bits[RISCV::Feature64Bit]);
  case 4:
    return (Bits[RISCV::FeatureStdExtF]);
  case 5:
    return (Bits[RISCV::FeatureStdExtD]);
  case 6:
    return (Bits[RISCV::FeatureStdExtA]);
  case 7:
    return (Bits[RISCV::FeatureStdExtA] && Bits[RISCV::Feature64Bit]);
  case 8:
    return (Bits[RISCV::FeatureStdExtM]);
  case 9:
    return (Bits[RISCV::FeatureStdExtM] && Bits[RISCV::Feature64Bit]);
  case 10:
    return (Bits[RISCV::FeatureStdExtF] && Bits[RISCV::Feature64Bit]);
  case 11:
    return (Bits[RISCV::FeatureStdExtD] && Bits[RISCV::Feature64Bit]);
  case 12:
    return (Bits[RISCV::FeatureStdExtC] && Bits[RISCV::FeatureStdExtF] && !Bits[RISCV::Feature64Bit]);
  case 13:
    return (Bits[RISCV::FeatureStdExtC] && !Bits[RISCV::Feature64Bit]);
  }
}

template<typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const void *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  InsnType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 5, 1) << 3;
    tmp |= fieldFromInstruction(insn, 6, 1) << 2;
    tmp |= fieldFromInstruction(insn, 7, 4) << 6;
    tmp |= fieldFromInstruction(insn, 11, 2) << 4;
    if (decodeUImmOperand<10>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 1:
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeSImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeFPR64CRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 5, 2) << 6;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 3) << 6;
    tmp |= fieldFromInstruction(insn, 5, 2) << 3;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 5, 1) << 6;
    tmp |= fieldFromInstruction(insn, 6, 1) << 2;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<7>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeSImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 2) << 6;
    tmp |= fieldFromInstruction(insn, 4, 3) << 2;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 5, 2) << 6;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 1) << 5;
    tmp |= fieldFromInstruction(insn, 3, 2) << 7;
    tmp |= fieldFromInstruction(insn, 5, 1) << 6;
    tmp |= fieldFromInstruction(insn, 6, 1) << 4;
    tmp |= fieldFromInstruction(insn, 12, 1) << 9;
    if (decodeSImmOperand<10>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0X2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeCLUIImmOperand(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 3) << 6;
    tmp |= fieldFromInstruction(insn, 5, 2) << 3;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeSImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 1) << 4;
    tmp |= fieldFromInstruction(insn, 3, 3) << 0;
    tmp |= fieldFromInstruction(insn, 6, 1) << 6;
    tmp |= fieldFromInstruction(insn, 7, 1) << 5;
    tmp |= fieldFromInstruction(insn, 8, 1) << 9;
    tmp |= fieldFromInstruction(insn, 9, 2) << 7;
    tmp |= fieldFromInstruction(insn, 11, 1) << 3;
    tmp |= fieldFromInstruction(insn, 12, 1) << 10;
    if (decodeSImmOperandAndLsl1<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 7, 3) << 6;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 1) << 4;
    tmp |= fieldFromInstruction(insn, 3, 2) << 0;
    tmp |= fieldFromInstruction(insn, 5, 2) << 5;
    tmp |= fieldFromInstruction(insn, 10, 2) << 2;
    tmp |= fieldFromInstruction(insn, 12, 1) << 7;
    if (decodeSImmOperandAndLsl1<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 7, 2) << 6;
    tmp |= fieldFromInstruction(insn, 9, 4) << 2;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 7, 3) << 6;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 24, 4);
    if (decodeUImmOperand<4>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 4);
    if (decodeUImmOperand<4>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 6);
    if (decodeUImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 20);
    if (decodeUImmOperand<20>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (decodeUImmOperand<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 7, 5) << 0;
    tmp |= fieldFromInstruction(insn, 25, 7) << 5;
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 7, 5) << 0;
    tmp |= fieldFromInstruction(insn, 25, 7) << 5;
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 7, 5) << 0;
    tmp |= fieldFromInstruction(insn, 25, 7) << 5;
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 27, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 27, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeUImmOperand<3>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 7, 1) << 10;
    tmp |= fieldFromInstruction(insn, 8, 4) << 0;
    tmp |= fieldFromInstruction(insn, 25, 6) << 4;
    tmp |= fieldFromInstruction(insn, 31, 1) << 11;
    if (decodeSImmOperandAndLsl1<13>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 12, 8) << 11;
    tmp |= fieldFromInstruction(insn, 20, 1) << 10;
    tmp |= fieldFromInstruction(insn, 21, 10) << 0;
    tmp |= fieldFromInstruction(insn, 31, 1) << 19;
    if (decodeSImmOperandAndLsl1<21>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeUImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeUImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (decodeUImmOperand<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeFPR32CRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 5, 1) << 6;
    tmp |= fieldFromInstruction(insn, 6, 1) << 2;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<7>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 2, 2) << 6;
    tmp |= fieldFromInstruction(insn, 4, 3) << 2;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 7, 2) << 6;
    tmp |= fieldFromInstruction(insn, 9, 4) << 2;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  }
}

template<typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const void *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset& Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint32_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      InsnType Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      InsnType FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      uint32_t ExpectedValue = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      InsnType PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      InsnType NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) || (~insn & NegativeMask);
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n":"PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // End llvm namespace
